#!/usr/bin/perl
use HTTP::Lite;
use Net::DNS;
use strict;

my $mode=$ARGV[0];
my $from;

$::ismail=q((?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff](?:[^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])*(?![^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])|["'][^\\\x80-\xff\n\015"]*(?:\\[^\x80-\xff][^\\\x80-\xff\n\015"]*)*["'])(?:\.(?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff](?:[^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])*(?![^(\040)<>@,;:&#".\\\[\]\000-\037\x80-\xff])|["'][^\\\x80-\xff\n\015"]*(?:\\[^\x80-\xff][^\\\x80-\xff\n\015"]*)*["']))*\.?@(?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\x80-\xff\n\015\[\]]|\\[^\x80-\xff])*\])(?:\.(?:[^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff]+(?![^(\040)<>@,;:&#"'.\\\[\]\000-\037\x80-\xff])|\[(?:[^\\\x80-\xff\n\015\[\]]|\\[^\x80-\xff])*\]))*);

foreach(<STDIN>) {
	$from=&mailadr($_) if(/^From:/);
}

my $http=new HTTP::Lite;
$http->method("GET");
$http->http11_mode(1);
$http->add_req_header("User-Agent","denkiyohou-autoresponder($from)");
my $url="http://denkiyohou.daiba.cx/?mail=$from&amp;m=$mode";
my $req=$http->request($url);
if($req eq 200) {
	my $tmp=$http->body();
}

sub mailadr {
	my($from)=shift;
	my $mail;
	if($from=~/($::ismail)/) {
		$mail=$1;
		if(&mailchk($mail) eq 1) {
			return $mail;
		}
	}
	return ''
}

sub mailchk {
	my ($mail)=shift;
	return 0 if($mail!~/$::ismail/o);

	my($user,$domain)=split(/\@/,$mail);
	my $resolver = new Net::DNS::Resolver;
	$resolver->udp_timeout(30);
	my @mx = mx($resolver, $domain);
	if (@mx) {
		return 1;
	} else {
		return 0;
	}
} 
